<template>
  <div :class="`item-selector p-2 ${this.class}`">
    <div class="header d-flex flex-row justify-content-between">
      <span><slot></slot></span>
      <span v-if="multiple && values.length"
        ><a href="#" @click.prevent="selectAll">Select all</a> /
        <a href="#" @click.prevent="selectNone">Select none</a></span
      >
    </div>
    <div class="list-group" v-if="values.length">
      <a
        v-for="value in values"
        href="#"
        @click.prevent="selectItem(value)"
        :id="`tables--${items[value]}`"
        :key="value"
        :class="`item list-group-item list-group-item-action ${
          selectedItems.includes(value) ? 'active' : ''
        }`"
        >{{ items[value] }}
        <span v-if="badges && badges[value]" class="badge bg-secondary">{{
          badges[value]
        }}</span></a
      >
    </div>
    <div v-else>No items for current selection</div>
  </div>
</template>

<script>
export default {
  name: "ItemSelector",
  emits: ["select", "update:modelValue"],
  data() {
    return {
      selectedItems: this.modelValue,
    };
  },
  computed: {
    selectedTitles() {
      return Array.from(this.selectedItems)
        .map((item) => this.items[item])
        .join(", ");
    },
    values() {
      return Object.keys(this.items);
    },
  },
  methods: {
    selectAll() {
      for (const item in this.items) {
        if (!this.selectedItems.includes(item)) this.selectItem(item);
      }
    },
    selectNone() {
      this.selectedItems = [];
      this.$emit("select", this.selectedItems);
      this.$emit("update:modelValue", this.selectedItems);
    },
    selectItem(item) {
      if (this.selectedItems.includes(item)) {
        this.selectedItems = this.selectedItems.filter(
          (value) => value != item
        );
      } else {
        if (!this.multiple) {
          this.selectedItems = [];
        }
        this.selectedItems.push(item);
      }
      this.$emit("select", this.selectedItems);
      this.$emit("update:modelValue", this.selectedItems);
      setTimeout(() => {
        const el = document.getElementById(`tables--${item}`);
        if (el) el.scrollIntoViewIfNeeded();
      }, 100);
    },
  },
  props: {
    badges: {
      type: Object,
      default: () => {},
    },
    modelValue: {
      type: Array,
      default: () => [],
    },
    class: {
      type: String,
      default: "col-12",
    },
    items: {
      type: Object,
      default: () => {},
    },
    multiple: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="scss">
.item-selector {
  .list-group {
    max-height: 16rem;
    overflow-y: scroll;
  }
}
.list-group-item.item {
  font-size: 0.8rem;
  &::after {
    display: inline;
    content: ">";
    right: 1rem;
    position: absolute;
  }
}
</style>
